package cache

import (
	"dc_golang_server_1/data_db_cache/dbcurd"
	"dc_golang_server_1/data_db_cache/model"
	"dc_golang_server_1/logger"
	"fmt"
	"go.uber.org/zap"
	"log"
	"strings"
	"time"
)

func initUCardUserMapAndSiminfoMapNoFamilyNum() {
	fmt.Println(time.Now(), "cache: initUCardUserMapAndSiminfoMapNoFamilyNum begin")
	var cardUserID uint32
	var temp model.CacheCardUserStruct
	// rows, err := dbcurd.PgDb.Query("SELECT id,role,name,sex,area_id,grade,class,student_num,first_topup_at is not null FROM u_card_user")
	rows, err := dbcurd.PgDb.Query("SELECT id,name,sex,area_id,grade,class,student_num FROM u_card_user WHERE delete_at is null")
	defer rows.Close()
	if err != nil {
		log.Panicln("Select u_card_user To Map rows", err)
	}
	var simInfo model.CacheSimInfoStruct
	for rows.Next() {
		err = rows.Scan(&cardUserID, &temp.Name, &temp.Sex, &temp.AreaID, &temp.Grade, &temp.Class, &temp.StuNum)
		if err != nil {
			log.Panicln("initUCardUserMapAndSiminfoMapNoFamilyNum rows.Scan", err)
		}
		err = dbcurd.PgDb.QueryRow("SELECT sim_id,area_service_id,month_talk_minutes,month_package_minutes,status,expiry_at FROM u_sim_info WHERE card_user_id=$1 AND area_service_id!=0 AND status!=0",
			cardUserID).Scan(
			&temp.SimCardID,
			&simInfo.AreaServiceID,
			&simInfo.MonthTalkMinutes,
			&simInfo.MonthPackageMinutes,
			&simInfo.Status,
			&simInfo.ExpiryAt)
		if err != nil {
			if strings.Contains(err.Error(), "no rows in result") {
				CardUserMap.Store(cardUserID, temp)
				continue
			}
			log.Panicln("Select u_sim_info To temp.SimCardID", err)
		}
		// todo1 考虑校验area_service_id
		simInfoMap.Store(temp.SimCardID, simInfo)
		CardUserMap.Store(cardUserID, temp)
	}
	// 处理完毕后，需要判断一次遍历过程中是否有错误产生
	if err = rows.Err(); err != nil {
		log.Panicln(time.Now(), "initUCardUserMapAndSiminfoMapNoFamilyNum rows.Err()", err)
	}

	fmt.Println(time.Now(), "cache: initUCardUserMapAndSiminfoMapNoFamilyNum OK")
}

func GetUCardUserInfo(cardUserID uint32) (model.CacheCardUserStruct, bool) {
	if s, ok := CardUserMap.Load(cardUserID); ok { // map有
		if v, ok4 := s.(model.CacheCardUserStruct); ok4 { //类型断言正确
			return v, true
		} else { //类型断言失败
			CardUserMap.Delete(cardUserID)
			logger.Log.Error("CardUserMap 类型断言错误",
				zap.Uint32("cardUserID", cardUserID),
				zap.String("src", "GetUCardUserInfo"))
		}
	} else {
		logger.Log.Error("CardUserMap 有问题，没数据",
			zap.Uint32("cardUserID", cardUserID),
			zap.String("src", "GetUCardUserInfo"))
	}

	var temp model.CacheCardUserStruct
	// todo1 再去查一盘库
	return temp, false
}
